package cn.iocoder.yudao.module.system.controller.admin.biz;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.framework.tenant.core.context.TenantContextHolder;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlyassesssuiciderisk.ElderlyAssessSuicideRiskPageReqVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlyassesssuiciderisk.ElderlyAssessSuicideRiskRespVO;
import cn.iocoder.yudao.module.system.controller.admin.biz.vo.elderlyassesssuiciderisk.ElderlyAssessSuicideRiskSaveReqVO;
import cn.iocoder.yudao.module.system.service.biz.ElderlyAssessSuicideRiskService;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.tags.Tag;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

@Tag(name = "管理后台 - 自杀风险评估量表")
@RestController
@RequestMapping("/elderly-assess-suicide-risk")
@Validated
public class ElderlyAssessSuicideRiskController {

    @Resource
    private ElderlyAssessSuicideRiskService elderlyAssessSuicideRiskService;

    @PostMapping("/create")
    @Operation(summary = "创建自杀风险评估量表")
    public CommonResult<Long> create(@Valid @RequestBody ElderlyAssessSuicideRiskSaveReqVO createReqVO) {
        if (createReqVO.getTenantId() == null) {
            createReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        return success(elderlyAssessSuicideRiskService.create(createReqVO));
    }

    @PutMapping("/update")
    @Operation(summary = "更新自杀风险评估量表")
    @TenantIgnore
    public CommonResult<Boolean> update(@Valid @RequestBody ElderlyAssessSuicideRiskSaveReqVO updateReqVO) {
        if (updateReqVO.getTenantId() == null) {
            updateReqVO.setTenantId(TenantContextHolder.getTenantId());
        }
        elderlyAssessSuicideRiskService.update(updateReqVO);
        return success(true);
    }

    @DeleteMapping("/delete")
    @Operation(summary = "删除自杀风险评估量表")
    @Parameter(name = "id", description = "编号", required = true)
    @TenantIgnore
    public CommonResult<Boolean> delete(@RequestParam("id") Long id) {
        elderlyAssessSuicideRiskService.delete(id);
        return success(true);
    }

    @GetMapping("/get")
    @Operation(summary = "获得自杀风险评估量表详情")
    @Parameter(name = "id", description = "编号", required = true, example = "1")
    @TenantIgnore
    public CommonResult<ElderlyAssessSuicideRiskRespVO> get(@RequestParam("id") Long id) {
        return success(elderlyAssessSuicideRiskService.get(id));
    }

    @GetMapping("/page")
    @Operation(summary = "获得自杀风险评估量表分页")
    @TenantIgnore
    public CommonResult<PageResult<ElderlyAssessSuicideRiskRespVO>> page(@Valid ElderlyAssessSuicideRiskPageReqVO pageReqVO) {
        if (pageReqVO.getTenantIds() == null) {
            pageReqVO.setTenantIds(new Long[]{TenantContextHolder.getTenantId()});
        }
        return success(elderlyAssessSuicideRiskService.getPage(pageReqVO));
    }
}
